let test = {
	attack: "50",
	decay: "83",
	sustain: "0",
	release: "50",
	name: "tasto",
};

const rack = document.getElementById("rack");

let createKnob = function (control, value) {
	let container = document.createElement("div");
	container.classList.add("control");

	let knob = document.createElement("input");
	knob.setAttribute("type", "range");
	knob.classList.add("input-knob");
	knob.dataset.fgcolor = "white";
	knob.setAttribute("name", control);
	knob.setAttribute("value", value);

	let label = document.createElement("label");
	label.setAttribute("for", control);
	label.innerHTML = control;

	container.appendChild(knob);
	container.appendChild(label);

	return container;
};

let deserialize = function (patch) {
	let module = document.createElement("div");
	module.classList.add("module");

	let name = document.createElement("input");
	name.id = "name";
	name.value = patch.name || "";
	name.placeholder = "Name";
	name.setAttribute("type", "text");

	module.appendChild(name);

	let save = document.createElement("input");
	save.setAttribute("type", "submit");
	save.id = "submit";
	save.value = "Save";

	module.appendChild(save);

	for (const [key, value] of Object.entries(patch)) {
		console.log(key, value);
		if (key == "name") {
			name.value = value;
		} else {
			module.appendChild(createKnob(key, value));
		}
	}

	rack.appendChild(module);
};

deserialize(test);
